using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using CrystalDecisions.Windows.Forms;

namespace BOE.BOEUserAudit
{
  public partial class BOEAuditRptViewer : Form
  {
    public enum AuditRptType
    {
      UserGroups,
      UserReports,
      GroupUsers,
      GroupReports,
      ReportUsers,
      ReportGroups,
      UserList
    }

    public BOEAuditRptViewer()
    {
      InitializeComponent();
    }

    private void BOEAuditRptViewer_FormClosing(object sender, FormClosingEventArgs e)
    {
      auditRptViewer.Dispose();
    }

    public BOEAuditRptViewer(DataSet dsAuditInfo, AuditRptType rptType)
    {
      InitializeComponent();
      switch (rptType)
      {
        case AuditRptType.UserList:
          ConfigureUserListReport(dsAuditInfo);
          break;
        case AuditRptType.UserGroups:
          ConfigureUserGroupsRpt(dsAuditInfo);
          break;
        case AuditRptType.UserReports:
          ConfigureUserRptsRpt(dsAuditInfo);
          break;
        case AuditRptType.GroupUsers:
          ConfigureGroupUserReport(dsAuditInfo);
          break;
        case AuditRptType.GroupReports:
          ConfigureGroupRptsRpt(dsAuditInfo);
          break;
        case AuditRptType.ReportGroups:
          ConfigureReportGroupReport(dsAuditInfo);
          break;
        case AuditRptType.ReportUsers:
          ConfigureReportUsersRpt(dsAuditInfo);
          break;
      }
    }

    private void ConfigureUserListReport(DataSet dsAuditInfo)
    {
      this.Text = "BusinessObjects Audit Report - User List";
      BOEUserListRpt auditRpt = new BOEUserListRpt();
      auditRpt.SetDataSource(dsAuditInfo);
      auditRptViewer.ReportSource = auditRpt;
      auditRptViewer.ToolPanelView = ToolPanelViewType.None;
    }

    private void ConfigureUserGroupsRpt(DataSet dsAuditInfo)
    {
      this.Text = "BusinessObjects Audit Report - Users with Groups";
      BOEUserGroupsRpt auditRpt = new BOEUserGroupsRpt();
      auditRpt.SetDataSource(dsAuditInfo);
      auditRptViewer.ReportSource = auditRpt;
      auditRptViewer.ToolPanelView = ToolPanelViewType.None;
    }

    private void ConfigureUserRptsRpt(DataSet dsAuditInfo)
    {
      this.Text = "BusinessObjects Audit Report - User List";
      BOEUserReportsRpt auditRpt = new BOEUserReportsRpt();
      auditRpt.SetDataSource(dsAuditInfo);
      auditRptViewer.ReportSource = auditRpt;
      auditRptViewer.ToolPanelView = ToolPanelViewType.None;
    }

    private void ConfigureGroupUserReport(DataSet dsAuditInfo)
    {
      this.Text = "BusinessObjects Audit Report - Groups with Users";
      BOEGroupUsersRpt auditRpt = new BOEGroupUsersRpt();
      auditRpt.SetDataSource(dsAuditInfo);
      auditRptViewer.ReportSource = auditRpt;
    }

    private void ConfigureGroupRptsRpt(DataSet dsAuditInfo)
    {
      this.Text = "BusinessObjects Audit Report - User List";
      BOEGroupReportRpt auditRpt = new BOEGroupReportRpt();
      auditRpt.SetDataSource(dsAuditInfo);
      auditRptViewer.ReportSource = auditRpt;
      auditRptViewer.ToolPanelView = ToolPanelViewType.None;
    }

    private void ConfigureReportGroupReport(DataSet dsAuditInfo)
    {
      this.Text = "BusinessObjects Audit Report - Reports with Groups";
      BOEReportGroupsRpt auditRpt = new BOEReportGroupsRpt();
      auditRpt.SetDataSource(dsAuditInfo);
      auditRptViewer.ReportSource = auditRpt;
    }

    private void ConfigureReportUsersRpt(DataSet dsAuditInfo)
    {
      this.Text = "BusinessObjects Audit Report - User List";
      BOEReportUsersRpt auditRpt = new BOEReportUsersRpt();
      auditRpt.SetDataSource(dsAuditInfo);
      auditRptViewer.ReportSource = auditRpt;
      auditRptViewer.ToolPanelView = ToolPanelViewType.None;
    }
  }
}
